﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using MuScreenManager;

namespace MuScreenManagerGame
{
    class Screen1 : MenuScreen
    {
        /// <summary>
        /// Generate an example menu screen
        /// </summary>
        /// <param name="title">Title of thus screen</param>
        public Screen1(string title)
            : base(title)
        { }

        /// <summary>
        /// Initialize the screen's options
        /// </summary>
        public override void Initialize()
        {
            //Some example menu options
            MenuItem item1 = new MenuItem("Option 1", new Vector2(screenManager.ScreenDimensions.X / 2, 100), screenManager);
            MenuItem item2 = new MenuItem("Option 2", new Vector2(screenManager.ScreenDimensions.X / 2, 150), screenManager);
            MenuOption item3 = new MenuOption("Options", new Vector2(screenManager.ScreenDimensions.X / 2, 200), new String[] { "One", "Two" }, new Vector2((screenManager.ScreenDimensions.X / 2) + 50, 200), screenManager);
            MenuItem item4 = new MenuItem("Close", new Vector2(screenManager.ScreenDimensions.X / 2, 300), screenManager);

            //Show setting the events for the items
            item1.OnButtonSelect += new EventHandler<MenuObjectEventArgs>(item1_OnButtonSelect);
            item2.OnButtonSelect += new EventHandler<MenuObjectEventArgs>(item2_OnButtonSelect);
            item4.OnButtonSelect += new EventHandler<MenuObjectEventArgs>(item4_OnButtonSelect);

            //Item state example
            item2.State = MenuObjectState.DrawOnly;

            //Add the items to the screen
            AddItem(item1);
            AddItem(item2);
            AddItem(item3);
            AddItem(item4);
        }

        /// <summary>
        /// Event methods
        /// </summary>

        private void item1_OnButtonSelect(object sender, MenuObjectEventArgs e)
        {
            throw new NotImplementedException();
        }

        private void item2_OnButtonSelect(object sender, MenuObjectEventArgs e)
        {
            throw new NotImplementedException();
        }

        private void item4_OnButtonSelect(object sender, MenuObjectEventArgs e)
        {
            //Create a screen to ask if you should close the game - layered over the existing screen
            ConfirmMessageScreen confirmScreen = new ConfirmMessageScreen("Close the game?");
            confirmScreen.OnConfirm += new EventHandler<EventArgs>(conirmScreen_OnConfirm);
            screenManager.AddScreen(confirmScreen);
        }

        private void conirmScreen_OnConfirm(object sender, EventArgs e)
        {
            screenManager.Game.Exit();
        }
    }
}
